My = {}


--[[ Public Parameter ]]
My.ID				= 0					--hc
My.HomType		= 0					--
My.Character		= {}					--i

My.Pos				= { X=0, Y=0 }		--ʒu
My.PrevPos		= { X=0, Y=0 }		--Öʒu
My.OwnerDistance			= 0		--OwnerƂ̋
My.PrevOwnerDistance	= 0		--OOwnerƂ̋

My.State			= ST_WAIT			--s
My.Command		= CMD_STAYALART	--w
My.Target			= 0					--UΏ
My.Chase			= 0					--ǂΏ
My.Guard			= 0					--qΏ
My.Support		= 0					--Ώ

My.Delay			= 0					--UAړAXLł̃fBC
My.UsingSkillList	= List.New()		--gp̃XL@fBCI\os.time()

My.CmdList		= List.New()
My.ResCmdList	= List.New()

My.Owner			= {}					--Owneȑ
My.Status			= {}					--Xe[^X
My.PriorityList	= {}					--D揇

My.ClearedToEngage		= false	--틖
My.SearchStateEnable	= true	--Actor̃Xe[^X擾
My.AIEnable		= true				--AI̓@蓮false


-----------------


--[[ Public ]]  --
function My.Initialize(myid)
	Trace("My Initialize", "Start")
	
	My.ID			= myid
	My.HomType	= GetV(V_HOMUNTYPE, myid)
	My.Status		= MY_STATUS
	My.Character = HomCharacter.GetCharacter(MY_CHARACTER)
	
	if My.Character.BaseCommand==CMD_ENGAGE then
		My.ClearedToEngage = true
	end
	
	My.Chase		= My.Owner.ID
	My.Support	= My.Owner.ID
	My.Guard		= My.Owner.ID
	
	-- Owner̃Xe[^Xi[Ă邪AȂׂFinding.luaGetActorDatag
	My.Owner.ID			= GetV(V_OWNER, myid)
	My.Owner.Status	= OWNER_STATUS
	
	Trace("MyOwner.ID: " .. My.Owner.ID , "", TRACE_PARAM)
	Trace("MyID	: " .. myid , "", TRACE_PARAM)
	Trace("Chara	: " .. My.Character.Name , "", TRACE_PARAM)
	
	Trace("My Initialize", "End")
end

--[[ Public ]]  --XV
function My.Update()
	Trace("My Update")
	My.PrevPos.X			= My.Pos.X
	My.PrevPos.Y 		= My.Pos.Y
	
	My.Pos.X, My.Pos.Y	= Position.GetPosition(My.ID)

	My.PrevOwnerDistance	= My.OwnerDistance
	My.OwnerDistance			= Position.GetDistanceFromOwner(My.ID)
end

--[[ Public ]]  --ҋ@H
function My.IsWait()
	if My.State==ST_WAIT then
		return true
	else
		return false
	end
end

--[[ Public ]]  --ړH
function My.IsMoving()
	if My.State==ST_MOVE then
		return true
	else
		return false
	end
end

--[[ Public ]]    --UH
function My.IsAttacking()
	if My.State==ST_ATACK then
		return true
	else
		return false
	end
end

--[[ Public ]]    --SH
function My.IsDead()
	if My.State==ST_DEAD then
		return true
	else
		return false
	end
end


--[[ Public ]]    --HPc
function My.GetHPPercent()
	local Rate = (My.GetNowHP() / My.GetMaxHP()) * 100 
	return Rate
end

--[[ Public ]]    --SPc
function My.GetSPPercent()
	local NowSP	= GetV (V_SP, My.ID) 
	local MaxSP	= GetV (V_MAXSP, My.ID) 
	local Rate		= (NowSP / MaxSP) * 100 
	return Rate
end

--[[ Public ]]    --őHP
function My.GetMaxHP()
	return GetV (V_MAXHP, My.ID) 
end

--[[ Public ]]    --őSP
function My.GetMaxSP()
	return GetV (V_MAXSP, My.ID) 
end	

--[[ Public ]]    --HP
function My.GetHP()
	return GetV (V_HP, My.ID) 
end

--[[ Public ]]    --SP
function My.GetSP()
	return GetV (V_SP, My.ID) 
end

--[[ Public ]]    --fBCH
function My.IsDelay()
	if TICK_TIME < My.Delay then
		return true
	else
		return false
	end
end

--[[ Public ]]    --fBCݒ
function My.SetDelay( TickTime )
	My.Delay = TICK_TIME + TickTime
end

--[[ Public ]]    --fBC
function My.GetDelay()
	return My.Delay
end

--[[ Public ]]    --XLgpH
function My.IsSkillActivate( SkillID )
	local SkillEndTime = List.Get(My.UsingSkillList, SkillID)
	
	if IsTrue(SkillEndTime) and OS_TIME<SkillEndTime then	--gp and XLIԂɂȂĂȂ
		return true
	else
		return false
	end
end

--[[ Public ]]    --gpXgɒǉ
function My.SkillActivate( SkillID )
	local SkillData	= SkillDataAccesser.GetSkillData(SkillID)
	local EndTime	= OS_TIME + SkillData.ActivateTime
	List.SetLeft(My.UsingSkillList, SkillData.ID, EndTime)
	My.SetDelay(SkillData.Delay)
end

--[[ Public ]]    --gpXg폜
function My.SkillDeActivate( SkillID )
	List.Set(My.UsingSkillList, SkillID, nil)
end

