--[[ Private Parameter ]]
local ImportSpanTick	= 100		--[hԊu
local ImportFileNum	= 5			--PŃ[ht@C̐

local ShowPackage		= false		--TraceAI [ht@C\
local TotalFileNum		= 0			--ImportLuaList ɋLqꂽt@Č
local LoadedFileNum	= 0			--[hς݂̃t@C
local PrevImportTime	= 0			--O񃍁[h


local ImportLuaList = {
	"Library/MetaTable",
	"Main/PublicConst",
	"Main/PublicParameter",
	
	"Library/Tracer",
	"Library/List",
	"Library/Ask",
	"Library/My",
	"Library/Position",
	"Library/Actor",
	"Library/ActorStatus",
	"Library/Evaluation",
	"Library/MobData",
	"Library/MobDataAccesser",
	"Library/ExceptDataAccesser",
	"Library/PlayerDataAccesser",
	"Library/SkillDataAccesser",
	"Library/Party",
	"Library/TargetPriority",
	"Library/Finding",
	"Library/math",
	"Library/SearchAction",
	"Library/MoveAction",
	"Library/AttackAction",
	
	"User/UserParameter",
	"User/HomCharacter",
	"User/FriendList",
	"User/ExceptList",	
	
	"Main/DecisionAI",
	"Main/BehaviorAI",
	
	"Main/TacticalAction/-/Chase",
	"Main/TacticalAction/-/Decoy",
	"Main/TacticalAction/-/Engage",
	"Main/TacticalAction/-/Guard",
	"Main/TacticalAction/-/Stealth",
	"Main/TacticalAction/-/Support",
	"Main/TacticalAction/-/StayAlart",
}

--[[ Public ]]
function ImportLua(myid)
	if not IMPORT_COMPLETE then		
		if TotalFileNum == 0 then
			if DEBUG_MODE then
				TraceAI("DEBUG_MODE : true")
			end
			TotalFileNum		= GetFileNum(ImportLuaList)
			--FileNumInCycle	= TotalFileNum / ImportFileNum
			FileNumInCycle	= ImportFileNum
		end
		
		if LOAD_TEST or (PrevImportTime+ImportSpanTick < TICK_TIME) then			
			local LoadEnd = LoadedFileNum + FileNumInCycle					--ǂݍݏIʒuݒ
			if TotalFileNum < LoadEnd then LoadEnd = TotalFileNum end	--ʒuC
			
			LoadedFileNum = LoadedFileNum + 1
			
			if TRACE_ON then TraceAI(TICK_TIME .. "  Now Importing") end
			
			local path
			for i=LoadedFileNum,  LoadEnd do
				path = ImportLuaList[i]
				
				if string.sub(path, 1, 20)=="Main/TacticalAction/" then
					if 		 Actor.IsLif(myid)		then path = (string.gsub(path, "-", "LIF"))
					elseif Actor.IsAmistr(myid)	then path = (string.gsub(path, "-", "AMISTR")) 
					elseif Actor.IsFilir(myid)		then path = (string.gsub(path, "-", "FILIR")) 
					elseif Actor.IsVanilmirth(myid)	then path = (string.gsub(path, "-", "VANILMIRTH")) 
					end
				end
				import(path)
				LoadedFileNum = i
			end
			
			--I
			if TotalFileNum < LoadedFileNum+1 then
				if TRACE_ON then TraceAI(TICK_TIME .. "  Import Complete") end
				IMPORT_COMPLETE = true
			else
				PrevImportTime	= TICK_TIME
			end
			
		end
	end
end


--[[ Private ]]
function import( package )
	if type( package ) == "string" then
		if ShowPackage then 
			TraceAI(TICK_TIME .. "   " .. package)
		end
		dofile( PACKAGE_DIR.."/"..package..PACKAGE_EXT )
		
	elseif type( package ) == "table" then
		for i, v in pairs( package ) do
			import( v )
		end
		
	else assert(nil) end
end

--[[ Private ]]
function GetFileNum( package )
	local FileNum = 0
	if type( package ) == "string" then
		FileNum = FileNum+1
		
	elseif type( package ) == "table" then
		for i, pac in pairs( package ) do
			if type( package ) == "string" then
				FileNum = FileNum+1
			else
				FileNum = FileNum + GetFileNum( pac )
			end
		end
		
	else assert(nil) end
	
	return FileNum
end

---------------------
