ifAttack = {}
local AttackAction = {}


---------------------


--[[ Public ]]  --
function ifAttack.InFight(TargetID)
	AttackAction.InFight(TargetID)	
end

--[[ Public ]]  --XL̎gp
function ifAttack.Skill(SkillID, Level, TargetID)
	AttackAction.Skill(SkillID, Level,TargetID)
end


-------------------


--[[ Private ]]  --
function AttackAction.InFight(TargetID)
	if not My.IsDelay() then		--fBCȂ
		Attack(My.ID, TargetID)
		My.SetDelay( DELAY_ATTACK )  --fBCݒ
	end
end

--[[ Private ]]  --XL̎gp
function AttackAction.Skill(SkillID, Level, TargetID)
	if not My.IsDelay() then											--fBCȂ
		if not My.IsSkillActivate(SkillID) then						--XLғĂȂ
			local SkillData = SkillDataAccesser.GetSkillData(SkillID)
			
			if SkillData.SP < My.GetSP() then						--SP
				if IsNil(Level)		then Level=1 end				--nil
				if IsNil(TargetID)	then TargetID = My.ID end	--nil
				
				SkillObject(My.ID, Level, SkillID, TargetID)
				My.SkillActivate(SkillID)								--gpXLɉ
			end
		end
	end
end

--[[ Private ]]  --H
function AttackAction.SkillGround(SkillID, Level, TgtX, TgtY)
	SkillGround(My.ID, Level, SkillID, TgtX, TgtY)
end

--[[ Private ]]  --x^XLǂ
function AttackAction.IsEnchantSkill( SkillID )
	-- [t
	if 8001<=SkillID and SkillID<=8004 then
		if SkillID==SKILL_TOUCH_OF_HEAL or SkillID==SKILL_EMERGENCY_AVOID or SkillID==SKILL_BRAIN_SURGERY or SkillID==SKILL_MENTAL_CHANGE then
			return true
		end
		
	-- A~Xg
	elseif 8005<=SkillID and SkillID<=8008 then
		if SkillID==SKILL_DEFENCE or SkillID==SKILL_ADAMANTIUM_SKIN then
			return true
		end
		
	-- tB[
	elseif 8009<=SkillID and SkillID<=8012 then
		if SkillID==SKILL_FLEET_MOVE or SkillID==SKILL_OVERED_SPEED then
			return true
		end
		
	-- oj~g
	elseif 8013<=SkillID and SkillID<=8016 then
		if SkillID==SKILL_CHANGE_INSTRUCTION then
			return true
		end
		
	end
	
	return false
end
	
--[[ Public ]]    --ߐڋH
function AttackAction.IsInFightRange(TargetID)
	local Dist = Position.GetDistanceFromMe (TargetID)
	if Dist == -1 then
		return false
	end
	
	local Range = GetV (V_ATTACKRANGE, ActorID)
	if Dist <= Range then
		return true
	else
		return false
	end
end

--[[ Public ]]    --XL͈͓H
function AttackAction.IsInSkillRange(TargetID, SkillID)
	local Dist = Position.GetDistanceFromMe(TargetID)
	if Dist == -1 then
		return false
	end
	
	local Range = GetV (V_SKILLATTACKRANGE, My.ID, SkillID)
	if Dist <= Range then
		return true
	else
		return false
	end
end


--[[ Public ]]    --ĂH
function AttackAction.IsInSight(TargetID)
	local Dist = Position.GetDistanceFromMe(TargetID)
	if 0<Dist and Dist<20 then
		return true
	else
		return false
	end
end

